(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/material/checkbox'), require('@angular/material/list'), require('@covalent/core/data-table'), require('@covalent/highlight'), require('@covalent/markdown')) :
    typeof define === 'function' && define.amd ? define('@covalent/flavored-markdown', ['exports', '@angular/core', '@angular/common', '@angular/material/checkbox', '@angular/material/list', '@covalent/core/data-table', '@covalent/highlight', '@covalent/markdown'], factory) :
    (factory((global.covalent = global.covalent || {}, global.covalent['flavored-markdown'] = {}),global.ng.core,global.ng.common,global.ng.material.checkbox,global.ng.material.list,global.covalent.core['data-table'],global.covalent.highlight,global.covalent.markdown));
}(this, (function (exports,core,common,checkbox,list,dataTable,highlight,markdown) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */
    var TdFlavoredListComponent = /** @class */ (function () {
        function TdFlavoredListComponent() {
            this.dense = false;
        }
        TdFlavoredListComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'cfm-list',
                        template: "<mat-list [attr.dense]=\"dense ? true : null\">\n  <ng-template let-line let-last=\"last\" ngFor [ngForOf]=\"lines\">\n    <mat-list-item>\n      <h4 matLine>\n        {{line.line}}\n      </h4>\n      <p *ngFor=\"let subline of line.sublines\" matLine>\n        {{subline}}\n      </p>\n      <mat-divider *ngIf=\"!last\"></mat-divider>\n    </mat-list-item>\n  </ng-template>\n</mat-list>\n",
                        styles: [""]
                    }] }
        ];
        TdFlavoredListComponent.propDecorators = {
            lines: [{ type: core.Input }],
            dense: [{ type: core.Input }]
        };
        return TdFlavoredListComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */
    var TdFlavoredMarkdownContainerDirective = /** @class */ (function () {
        function TdFlavoredMarkdownContainerDirective(viewContainerRef, _renderer) {
            this.viewContainerRef = viewContainerRef;
            this._renderer = _renderer;
        }
        /**
         * @return {?}
         */
        TdFlavoredMarkdownContainerDirective.prototype.clear = /**
         * @return {?}
         */
            function () {
                this._renderer.setProperty(this.viewContainerRef.element.nativeElement, 'innerHTML', '');
                this.viewContainerRef.clear();
            };
        TdFlavoredMarkdownContainerDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[tdFlavoredMarkdownContainer]',
                    },] }
        ];
        /** @nocollapse */
        TdFlavoredMarkdownContainerDirective.ctorParameters = function () {
            return [
                { type: core.ViewContainerRef },
                { type: core.Renderer2 }
            ];
        };
        return TdFlavoredMarkdownContainerDirective;
    }());
    var TdFlavoredMarkdownComponent = /** @class */ (function () {
        function TdFlavoredMarkdownComponent(_componentFactoryResolver, _renderer, _changeDetectorRef, _injector) {
            this._componentFactoryResolver = _componentFactoryResolver;
            this._renderer = _renderer;
            this._changeDetectorRef = _changeDetectorRef;
            this._injector = _injector;
            this._components = {};
            /**
             * contentReady?: function
             * Event emitted after the markdown content rendering is finished.
             */
            this.onContentReady = new core.EventEmitter();
        }
        Object.defineProperty(TdFlavoredMarkdownComponent.prototype, "content", {
            /**
             * content?: string
             *
             * Markdown format content to be parsed as material/covalent markup.
             * Used to load data dynamically.
             *
             * e.g. README.md content.
             */
            set: /**
             * content?: string
             *
             * Markdown format content to be parsed as material/covalent markup.
             * Used to load data dynamically.
             *
             * e.g. README.md content.
             * @param {?} content
             * @return {?}
             */ function (content) {
                this._content = content;
                this._loadContent(this._content);
                this._changeDetectorRef.markForCheck();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        TdFlavoredMarkdownComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this._content) {
                    this._loadContent((( /** @type {?} */(this.container.viewContainerRef.element.nativeElement))).textContent);
                    Promise.resolve().then(function () {
                        _this._changeDetectorRef.markForCheck();
                    });
                }
            };
        /**
         * @param {?} markdown
         * @return {?}
         */
        TdFlavoredMarkdownComponent.prototype._loadContent = /**
         * @param {?} markdown
         * @return {?}
         */
            function (markdown$$1) {
                var _this = this;
                if (markdown$$1 && markdown$$1.trim().length > 0) {
                    this.container.clear();
                    markdown$$1 = markdown$$1.replace(/^(\s|\t)*\n+/g, '')
                        .replace(/(\s|\t)*\n+(\s|\t)*$/g, '');
                    // Split markdown by line characters
                    /** @type {?} */
                    var lines = markdown$$1.split('\n');
                    // check how much indentation is used by the first actual markdown line
                    /** @type {?} */
                    var firstLineWhitespace = lines[0].match(/^(\s|\t)*/)[0];
                    // Remove all indentation spaces so markdown can be parsed correctly
                    /** @type {?} */
                    var startingWhitespaceRegex_1 = new RegExp('^' + firstLineWhitespace);
                    lines = lines.map(function (line) {
                        return line.replace(startingWhitespaceRegex_1, '');
                    });
                    // Join lines again with line characters
                    markdown$$1 = __spread(lines, ['', '']).join('\n');
                    markdown$$1 = this._replaceCodeBlocks(markdown$$1);
                    markdown$$1 = this._replaceCheckbox(markdown$$1);
                    markdown$$1 = this._replaceTables(markdown$$1);
                    markdown$$1 = this._replaceLists(markdown$$1);
                    /** @type {?} */
                    var keys = Object.keys(this._components);
                    // need to sort the placeholders in order of encounter in markdown content
                    keys = keys.sort(function (compA, compB) {
                        return markdown$$1.indexOf(compA) > markdown$$1.indexOf(compB) ? 1 : -1;
                    });
                    this._render(markdown$$1, keys[0], keys);
                    this.onContentReady.emit();
                    Promise.resolve().then(function () {
                        _this._changeDetectorRef.markForCheck();
                    });
                }
            };
        /**
         * @param {?} markdown
         * @param {?} key
         * @param {?} keys
         * @return {?}
         */
        TdFlavoredMarkdownComponent.prototype._render = /**
         * @param {?} markdown
         * @param {?} key
         * @param {?} keys
         * @return {?}
         */
            function (markdown$$1, key, keys) {
                if (!markdown$$1) {
                    return;
                }
                if (markdown$$1.indexOf(key) > -1) {
                    /** @type {?} */
                    var markdownParts = markdown$$1.split(key);
                    keys.shift();
                    this._render(markdownParts[0], undefined, undefined);
                    this.container.viewContainerRef.insert(this._components[key].hostView, this.container.viewContainerRef.length);
                    this._components[key] = undefined;
                    delete this._components[key];
                    this._render(markdownParts[1], keys[0], keys);
                }
                else {
                    /** @type {?} */
                    var contentRef = this._componentFactoryResolver
                        .resolveComponentFactory(markdown.TdMarkdownComponent).create(this._injector);
                    contentRef.instance.content = markdown$$1;
                    contentRef.instance.refresh();
                    this.container.viewContainerRef.insert(contentRef.hostView, this.container.viewContainerRef.length);
                }
            };
        /**
         * @template T
         * @param {?} markdown
         * @param {?} type
         * @param {?} regExp
         * @param {?} replacerFunc
         * @return {?}
         */
        TdFlavoredMarkdownComponent.prototype._replaceComponent = /**
         * @template T
         * @param {?} markdown
         * @param {?} type
         * @param {?} regExp
         * @param {?} replacerFunc
         * @return {?}
         */
            function (markdown$$1, type, regExp, replacerFunc) {
                var _this = this;
                /** @type {?} */
                var componentIndex = 0;
                return markdown$$1.replace(regExp, function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    /** @type {?} */
                    var componentFactory = _this._componentFactoryResolver.resolveComponentFactory(type);
                    /** @type {?} */
                    var componentRef = componentFactory.create(_this._injector);
                    replacerFunc.apply(void 0, __spread([componentRef], args));
                    /** @type {?} */
                    var key = '[' + componentFactory.selector + '-placeholder-' + componentIndex++ + ']';
                    _this._components[key] = componentRef;
                    return key;
                });
            };
        /**
         * @param {?} markdown
         * @return {?}
         */
        TdFlavoredMarkdownComponent.prototype._replaceCheckbox = /**
         * @param {?} markdown
         * @return {?}
         */
            function (markdown$$1) {
                var _this = this;
                /** @type {?} */
                var checkboxRegExp = /(?:^|\n)- \[(x| )\](.*)/gi;
                return this._replaceComponent(markdown$$1, checkbox.MatCheckbox, checkboxRegExp, function (componentRef, match, checked, label) {
                    componentRef.instance.checked = !!checked.trim();
                    componentRef.instance.disabled = true;
                    componentRef.instance.labelPosition = 'after';
                    _this._renderer.setProperty((( /** @type {?} */(componentRef.instance._elementRef.nativeElement)))
                        .getElementsByClassName('mat-checkbox-label')[0], 'innerHTML', label);
                });
            };
        /**
         * @param {?} markdown
         * @return {?}
         */
        TdFlavoredMarkdownComponent.prototype._replaceCodeBlocks = /**
         * @param {?} markdown
         * @return {?}
         */
            function (markdown$$1) {
                /** @type {?} */
                var codeBlockRegExp = /(?:^|\n)```(.*)\n([\s\S]*?)\n```/g;
                return this._replaceComponent(markdown$$1, highlight.TdHighlightComponent, codeBlockRegExp, function (componentRef, match, language, codeblock) {
                    if (language) {
                        componentRef.instance.language = language;
                    }
                    componentRef.instance.content = codeblock;
                });
            };
        /**
         * @param {?} markdown
         * @return {?}
         */
        TdFlavoredMarkdownComponent.prototype._replaceTables = /**
         * @param {?} markdown
         * @return {?}
         */
            function (markdown$$1) {
                /** @type {?} */
                var tableRgx = /^ {0,3}\|?.+\|.+\n[ \t]{0,3}\|?[ \t]*:?[ \t]*(?:-|=){2,}[ \t]*:?[ \t]*\|[ \t]*:?[ \t]*(?:-|=){2,}[\s\S]+?(?:\n\n|~0)/gm;
                return this._replaceComponent(markdown$$1, dataTable.TdDataTableComponent, tableRgx, function (componentRef, match) {
                    /** @type {?} */
                    var dataTableLines = match.replace(/(\s|\t)*\n+(\s|\t)*$/g, '').split('\n');
                    /** @type {?} */
                    var columns = dataTableLines[0].split('|')
                        .filter(function (col) { return col; })
                        .map(function (s) { return s.trim(); });
                    /** @type {?} */
                    var alignment = dataTableLines[1].split('|').filter(function (v) { return v; }).map(function (s) { return s.trim(); });
                    componentRef.instance.columns = columns.map(function (col, index) {
                        /** @type {?} */
                        var widths = alignment[index].split('---');
                        /** @type {?} */
                        var min = parseInt(widths[0], 10);
                        /** @type {?} */
                        var max = parseInt(widths[1], 10);
                        /** @type {?} */
                        var width = { min: min, max: max };
                        if (isNaN(min) && isNaN(max)) {
                            width = undefined;
                        }
                        else if (isNaN(max)) {
                            width.max = undefined;
                        }
                        else if (isNaN(min)) {
                            width.min = undefined;
                        }
                        return {
                            label: col,
                            name: col.toLowerCase().trim(),
                            numeric: /^--*[ \t]*:[ \t]*$/.test(alignment[index]),
                            width: width,
                        };
                    });
                    /** @type {?} */
                    var data = [];
                    var _loop_1 = function (i) {
                        /** @type {?} */
                        var rowSplit = dataTableLines[i].split('|')
                            .filter(function (cell) { return cell; })
                            .map(function (s) { return s.trim(); });
                        /** @type {?} */
                        var row = {};
                        columns.forEach(function (col, index) {
                            /** @type {?} */
                            var rowSplitCell = rowSplit[index];
                            if (rowSplitCell) {
                                row[col.toLowerCase().trim()] = rowSplitCell.replace(/`(.*)`/, function (m, value) {
                                    return value;
                                });
                            }
                        });
                        data.push(row);
                    };
                    for (var i = 2; i < dataTableLines.length; i++) {
                        _loop_1(i);
                    }
                    componentRef.instance.data = data;
                    componentRef.instance.sortable = true;
                    componentRef.instance.onSortChange.subscribe(function (event) {
                        componentRef.instance.data = data.sort(function (a, b) {
                            /** @type {?} */
                            var compA = a[event.name];
                            /** @type {?} */
                            var compB = b[event.name];
                            /** @type {?} */
                            var direction = 0;
                            if (!Number.isNaN(Number.parseFloat(compA)) && !Number.isNaN(Number.parseFloat(compB))) {
                                direction = Number.parseFloat(compA) - Number.parseFloat(compB);
                            }
                            else {
                                if (compA < compB) {
                                    direction = -1;
                                }
                                else if (compA > compB) {
                                    direction = 1;
                                }
                            }
                            return direction * (event.order === dataTable.TdDataTableSortingOrder.Descending ? -1 : 1);
                        });
                        componentRef.instance.refresh();
                    });
                    setTimeout(function () {
                        componentRef.instance.refresh();
                    });
                });
            };
        /**
         * @param {?} markdown
         * @return {?}
         */
        TdFlavoredMarkdownComponent.prototype._replaceLists = /**
         * @param {?} markdown
         * @return {?}
         */
            function (markdown$$1) {
                /** @type {?} */
                var listRegExp = /(?:^|\n)(( *\+)[ |\t](.*)\n)+/g;
                return this._replaceComponent(markdown$$1, TdFlavoredListComponent, listRegExp, function (componentRef, match) {
                    /** @type {?} */
                    var lineTexts = match.split(new RegExp('\\n {' + (match.indexOf('+') - 1).toString() + '}\\+[ |\\t]'));
                    lineTexts.shift();
                    /** @type {?} */
                    var lines = [];
                    lineTexts.forEach(function (text, index) {
                        /** @type {?} */
                        var sublineTexts = text.split(/\n *\+ /);
                        lines.push({
                            line: sublineTexts.shift(),
                            sublines: sublineTexts.map(function (subline) {
                                return subline.trim();
                            }),
                        });
                    });
                    componentRef.instance.lines = lines;
                });
            };
        TdFlavoredMarkdownComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'td-flavored-markdown',
                        template: "<div tdFlavoredMarkdownContainer>\n  <ng-content></ng-content>\n</div>",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [":host ::ng-deep td-markdown:first-of-type>div:first-of-type>h1:first-of-type,:host ::ng-deep td-markdown:first-of-type>div:first-of-type>h2:first-of-type{margin-top:0}:host ::ng-deep mat-checkbox,:host ::ng-deep td-data-table,:host ::ng-deep td-highlight{display:block}:host ::ng-deep mat-checkbox:last-of-type,:host ::ng-deep td-data-table,:host ::ng-deep td-highlight{margin-bottom:16px}:host ::ng-deep :not(pre)>code{font-family:Menlo,Monaco,\"Andale Mono\",\"lucida console\",\"Courier New\",monospace;padding-left:2px;padding-right:2px}"]
                    }] }
        ];
        /** @nocollapse */
        TdFlavoredMarkdownComponent.ctorParameters = function () {
            return [
                { type: core.ComponentFactoryResolver },
                { type: core.Renderer2 },
                { type: core.ChangeDetectorRef },
                { type: core.Injector }
            ];
        };
        TdFlavoredMarkdownComponent.propDecorators = {
            content: [{ type: core.Input, args: ['content',] }],
            onContentReady: [{ type: core.Output, args: ['contentReady',] }],
            container: [{ type: core.ViewChild, args: [TdFlavoredMarkdownContainerDirective,] }]
        };
        return TdFlavoredMarkdownComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */
    var CovalentFlavoredMarkdownModule = /** @class */ (function () {
        function CovalentFlavoredMarkdownModule() {
        }
        CovalentFlavoredMarkdownModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            checkbox.MatCheckboxModule,
                            list.MatListModule,
                            dataTable.CovalentDataTableModule,
                            highlight.CovalentHighlightModule,
                            markdown.CovalentMarkdownModule,
                        ],
                        declarations: [
                            TdFlavoredListComponent,
                            TdFlavoredMarkdownComponent,
                            TdFlavoredMarkdownContainerDirective,
                        ],
                        exports: [
                            TdFlavoredMarkdownComponent,
                        ],
                        entryComponents: [
                            dataTable.TdDataTableComponent,
                            markdown.TdMarkdownComponent,
                            highlight.TdHighlightComponent,
                            checkbox.MatCheckbox,
                            TdFlavoredListComponent,
                        ],
                    },] }
        ];
        return CovalentFlavoredMarkdownModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */

    exports.TdFlavoredMarkdownContainerDirective = TdFlavoredMarkdownContainerDirective;
    exports.TdFlavoredMarkdownComponent = TdFlavoredMarkdownComponent;
    exports.CovalentFlavoredMarkdownModule = CovalentFlavoredMarkdownModule;
    exports.ɵa = TdFlavoredListComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=covalent-flavored-markdown.umd.js.map