import { AfterViewInit, Renderer2, ChangeDetectorRef, EventEmitter, ViewContainerRef, ComponentFactoryResolver, Injector, ComponentRef } from '@angular/core';
export declare class TdFlavoredMarkdownContainerDirective {
    viewContainerRef: ViewContainerRef;
    private _renderer;
    constructor(viewContainerRef: ViewContainerRef, _renderer: Renderer2);
    clear(): void;
}
export interface IReplacerFunc<T> {
    (componentRef: ComponentRef<T>, ...args: any[]): void;
}
export declare class TdFlavoredMarkdownComponent implements AfterViewInit {
    private _componentFactoryResolver;
    private _renderer;
    private _changeDetectorRef;
    private _injector;
    private _content;
    private _components;
    /**
     * content?: string
     *
     * Markdown format content to be parsed as material/covalent markup.
     * Used to load data dynamically.
     *
     * e.g. README.md content.
     */
    content: string;
    /**
     * contentReady?: function
     * Event emitted after the markdown content rendering is finished.
     */
    onContentReady: EventEmitter<undefined>;
    container: TdFlavoredMarkdownContainerDirective;
    constructor(_componentFactoryResolver: ComponentFactoryResolver, _renderer: Renderer2, _changeDetectorRef: ChangeDetectorRef, _injector: Injector);
    ngAfterViewInit(): void;
    private _loadContent;
    private _render;
    private _replaceComponent;
    private _replaceCheckbox;
    private _replaceCodeBlocks;
    private _replaceTables;
    private _replaceLists;
}
